-- these settings cause abuot a thousand "errors", really warnings {-# OPTIONS_GHC -Wall -Werror -fno-warn-missing-signatures #-}

--{- imports
--{- xmonad & others
import           XMonad
import qualified XMonad.StackSet as W
import qualified Data.Map        as M
--}
--{- util
import XMonad.Util.EZConfig  (additionalKeysP, removeKeysP, checkKeymap, mkKeymap)
import XMonad.Util.SpawnOnce ( spawnOnce )
--}
--{- actions
import XMonad.Actions.DynamicWorkspaces
import XMonad.Actions.CopyWindow
import XMonad.Actions.CycleWS       ( prevWS, nextWS)
import XMonad.Actions.CycleRecentWS ( cycleRecentWS )
--}
--{- hooks
import XMonad.Hooks.EwmhDesktops ( ewmh, fullscreenEventHook)
import XMonad.Hooks.ManageDocks  ( avoidStruts, docks)
import XMonad.Hooks.DynamicLog   ( statusBar, ppCurrent, ppHidden, ppTitle, ppOrder, ppSep, xmobarPP, xmobarColor, wrap)
import XMonad.Hooks.SetWMName    ( setWMName )
--}
--{- layouts
import XMonad.Layout.NoBorders ( smartBorders )
import XMonad.Layout.Renamed   ( Rename(..), renamed)
import XMonad.Layout.Spacing   ( Border(..), spacingRaw)
--}
--}
--{- my programs
myTerminal :: String
myTerminal = "st"
--}
--{- xmobar
myXmobarPP =
 xmobarPP
 { ppCurrent = xmobarColor (mfg!!0) "" -- currently focused workspace
 , ppHidden  = xmobarColor (mfg!!1) "" -- currently nonempty but unfocusued workspace
 , ppTitle   = xmobarColor (mfg!!0) "" -- title of currently focused program
 , ppSep     = " | "
 , ppOrder   = \(ws:l:t:ex) -> [ws, l] ++ ex ++ [t]
 }
--}
--{- colors
mfg = ["#EEFFFF","#6C6C6C"]
--}
--{- workspaces
myWorkspaces :: [String]
myWorkspaces =
 [ "I"
 , "II"
 , "III"
 , "IV"
 , "V"
 , "VI"
 , "VII"
 , "VIII"
 , "IX"
 , "X"
 ]
--}
--{- hooks
--{- startuphook
myStartupHook :: X ()
myStartupHook = do
  setWMName "xmonad"
  spawnOnce "feh --bg-fill ~/.wallpaper.jpg"
--}
--{- layouthook
myLayoutHook = smartBorders . avoidStruts $ myMainLayout
myMainLayout =
  renamed [Replace "Tall"] tiled
    ||| renamed [Replace "Wide"] (Mirror tiled)
    ||| Full
 where
  tiled =
    spacingRaw True
               (Border outer outer outer outer)
               True
               (Border inner inner inner inner)
               True
      $ Tall 1 (3 / 100) (1 / 2)
  outer = 3
  inner = 5
--}
--{- handleeventhook
myHandleEventHook = fullscreenEventHook <+> handleEventHook def
--}
--}
--{- keybinds
-- myKeys :: [(String, X ())]
myKeys = -- \conf -> mkKeymap conf (
 [ ("M-<Return>"    , spawn myTerminal)
 , ("M-t"           , withFocused $ windows . \w -> W.float w $ mfloatMolds'!!0)
 , ("M-S-c"         , kill1)
 , ("M-c"           , kill)
 , ("M-<space>"     , sendMessage NextLayout)
 -- , ("M-S-<space>"   , setLayout $ XMonad.layoutHook myConfig) -- errors out,
 -- not sure what was the goal here, reset to first layout?
 , ("M-n"           , refresh)
 , ("M-j"           , windows W.focusDown)
 , ("M-k"           , windows W.focusUp)
 , ("M-S-j"         , windows W.swapDown)
 , ("M-S-k"         , windows W.swapUp)
 , ("M-m"           , windows W.focusMaster)
 , ("M-S-<Return>"   , windows W.swapMaster)
 , ("M-h"           , sendMessage Shrink)
 , ("M-l"           , sendMessage Expand)
 , ("M-S-t"         , withFocused $ windows . W.sink)
 , ("M-p"           , spawn $ "dmenu_run -fn \"Iosevka\" -nb \"#11100F\" -nf \"#d2d0ce\" -sf \"#11100F\" -sb \"" ++ mfg!!0 ++"\"")
 , ("M-S-<Up>"      , spawn "playerctl play")
 , ("M-S-l"         , spawn "slock")
 , ("M-S-<Down>"    , spawn "playerctl pause")
 , ("M-S-<Right>"   , spawn "playerctl next")
 , ("M-S-<Left>"    , spawn "playerctl previous")
 , ("M-C-<Right>"   , spawn "amixer sset Master 5%+")
 , ("M-C-<Left>"    , spawn "amixer sset Master 5%-")
 , ("M-C-<Down>"    , spawn "amixer sset Master mute")
 , ("M-C-<Up>"      , spawn "amixer sset Master unmute")
 , ("M-o"           , spawn "flameshot gui")
 , ("M-,"           , prevWS)
 , ("M-."           , nextWS)
 , ("M-<Tab>"       , cycleRecentWS [xK_Tab] xK_Tab xK_Tab)
 ]
 -- use <> instead of ++, looks cooler, and is more general, so better for
 -- learning Haskell w/
--  <> [ (concat ["M-", m, show i], withNthWorkspace f (i-1)) | (m, f) <-
--   [ ("",   W.greedyView) -- Switch to workspace
--   , ("S-", W.shift     ) -- Move client to workspace
--   ]
--   , (i, k) <- [9, 0 .. 8] [0..9])
--   ]
 <> concat [
  [ (concat ["M-",m, show k], withNthWorkspace f i) | (m, f) <-
   [ ("",     W.greedyView ) -- view workspace
   , ("M1-",  W.view       ) -- view workspace #2
   , ("S-",   W.shift      ) -- shift to workspace
   , ("C-S-", copy         ) -- copy to workspace
   ]
  ]
  | (i, k) <- (zip [9, 0 .. 8] [0..9])
 ]
    where --{-
        b = W.RationalRect
        -- make x and y equal to padding, where the window always left and top aligns
        l = \x y w h -> b x y (min (w-x) $ 1-x-x) (min (h-y) $ 1-y-y)
        -- same as l, but with bottom right anchored x & y
        r = \x y w h -> b (max x $ 1-w) (max y $ 1-h) (max 0.01 (min (w-x) $ 1-x-x)) $ max 0.01 (min (h-y) $ 1-y-y)
        mfloatMolds' =
         [ b 0.05 0.05 0.25 0.25 -- full  mold
         , l 0.05 0.05 0.5  1    -- left  mold
         , r 0.05 0.05 0.5  1    -- right mold
         , b 0    0    1    1    -- fullscreen float
         , r 0.05 0.05 0.5  0.5  -- popup player float
         , r 0.05 0.05 0.25 0.25 -- popup player float #2
         , l 0.05 0.05 0.5  0.5  -- popup player float #3
         , l 0.05 0.05 0.25 0.25 -- popup player float #4
         ]
--}
--}
--{- main
main :: IO ()
main =
 xmonad
 .   ewmh
 .   docks
 =<< statusBar "xmobar" myXmobarPP (\x -> (XMonad.modMask x, xK_r)) myConfig
--}
--{- config
myConfig = def
 { terminal           = myTerminal
 , focusedBorderColor = mfg!!0
 , normalBorderColor  = mfg!!1
 , modMask            = mod4Mask
 , borderWidth        = 2
 , focusFollowsMouse  = False
 , handleEventHook    = myHandleEventHook
 , layoutHook         = myLayoutHook
 , startupHook        = myStartupHook
 , workspaces         = myWorkspaces
 -- , keys = myKeys
 }
 `removeKeysP` [ a | (a,b) <- myKeys]
 `additionalKeysP` myKeys
--}

